package visitorDemo;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import visitors.*;



/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class DemoFrame extends javax.swing.JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 8811498700919993686L;
	private JSplitPane centerSplitPane;
	private JTextField visitorTF;
	private JButton executeBtn;
	private JComboBox hostCBx;
	private JPanel controlPnl;
	private JTextArea outputTA;
	private JScrollPane textSPane;
	private JPanel canvasPnl;
	
	private IPaintCmd paintCmd = new IPaintCmd(){
		public void apply(Graphics g){
		}
	};

	/**
	* Auto-generated main method to display this JFrame
	*/
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				DemoFrame inst = new DemoFrame();
				inst.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
				inst.start();
			}
		});
	}
	
	public DemoFrame() {
		super();
		initGUI();
	}
	
	public void start(){
		hostCBx.addItem(new HostA());
		hostCBx.addItem(new HostB());
		hostCBx.addItem(new HostC());
		setLocationRelativeTo(null);
		setVisible(true);		
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			{
				centerSplitPane = new JSplitPane();
				getContentPane().add(centerSplitPane, BorderLayout.CENTER);
				{
					canvasPnl = new JPanel() {
						/**
						 * 
						 */
						private static final long serialVersionUID = -517612402679798317L;

						public void paintComponent(Graphics g){
							super.paintComponent(g);
							paintCmd.apply(g);
						}
					};
					centerSplitPane.add(canvasPnl, JSplitPane.LEFT);
					canvasPnl.setPreferredSize(new java.awt.Dimension(177, 260));
				}
				{
					textSPane = new JScrollPane();
					centerSplitPane.add(textSPane, JSplitPane.RIGHT);
					{
						outputTA = new JTextArea();
						textSPane.setViewportView(outputTA);
						outputTA.setText("");
					}
				}
			}
			{
				controlPnl = new JPanel();
				getContentPane().add(controlPnl, BorderLayout.NORTH);
				controlPnl.setBackground(new java.awt.Color(230,255,254));
				{
					ComboBoxModel hostCBxModel = 
						new DefaultComboBoxModel();
					hostCBx = new JComboBox();
					controlPnl.add(hostCBx);
					hostCBx.setModel(hostCBxModel);
				}
				{
					executeBtn = new JButton();
					controlPnl.add(executeBtn);
					executeBtn.setText("Execute!");
					executeBtn.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							System.out.println("executeBtn.actionPerformed, event="+evt);
							Object result = ((IHost) hostCBx.getSelectedItem()).execute(loadVisitor(visitorTF.getText()), DemoFrame.this);
							outputTA.append("RESULT = "+result.toString()+"\n");
						}
					});
				}
				{
					visitorTF = new JTextField();
					controlPnl.add(visitorTF);
					visitorTF.setText("Visitor1");
				}
			}
			pack();
			this.setSize(644, 313);
		} catch (Exception e) {
		    //add your error handling code here
			e.printStackTrace();
		}
	}
	
	public void setPaintCmd(IPaintCmd cmd){
		this.paintCmd = cmd;
		canvasPnl.repaint();
	}
	
	private IVisitor loadVisitor(String className){
		try {
			java.lang.reflect.Constructor<?> c = Class.forName("visitors.impl."+className)
					.getConstructors()[0];
			Object[] args = new Object[] {};
			return (IVisitor) c.newInstance(args);
		}

		catch (Exception ex) {
			System.err.println("DemoFrame.loadVisitor() error: "+ ex);
			return IVisitor.NULL_VISITOR;
		}

	}

}
