package visitors.impl;

import java.awt.Color;
import java.awt.Graphics;

import visitors.*;
import visitorDemo.*;

public class Visitor2 implements IVisitor {

	@Override
	public Object caseHostA(HostA host, Object... params) {
		((DemoFrame)params[0]).setPaintCmd(new IPaintCmd(){
			@Override
			public void apply(Graphics g) {
				g.setColor(Color.BLUE);
				g.fillOval(50, 50, 30, 15);
			}
		});
		return "Blue oval made.";
	}

	@Override
	public Object caseHostB(HostB host, Object... params) {
		((DemoFrame)params[0]).setPaintCmd(new IPaintCmd(){
			@Override
			public void apply(Graphics g) {
				g.setColor(Color.RED);
				g.fillRect(50, 50, 30, 15);
			}
		});
		return "Red rectangle made";
	}

	@Override
	public Object caseHostC(HostC host, Object... params) {
		((DemoFrame)params[0]).setPaintCmd(new IPaintCmd(){
			@Override
			public void apply(Graphics g) {
				g.setColor(Color.GREEN);
				g.fillRoundRect(50, 50, 30, 15, 5, 5);
			}
		});
		return "Green rounded rectangle made";
	}

}
